signal_mgr
	var
		list/m_map
		m_blocked = FALSE

	proc
		blockSignals(block_value)
			. = m_blocked
			m_blocked = block_value

		signalsBlocked()
			return m_blocked

		connections()
			return (m_map ? m_map : list())

		connect(signal, destination, slot)
			var/signal_connection/connector = new(signal, destination, slot)

			if(!m_map)
				m_map = list(connector)
				return 1
			else
				for(var/signal_connection/C in m_map)
					if(C.equals(connector))
						return 0
				m_map += connector
				return 1

		disconnect(signal, destination, slot)
			if(m_map)
				var/signal_connection/match = new(signal, destination, slot)

				for(var/signal_connection/C in m_map)
					if(C.equals(match))
						m_map -= C
						if(!m_map.len) m_map = null
						return 1
			return 0

		clear()
			m_map = null

		emit(signal, ...)
			if(!m_blocked)
				var/list/arguments = args.Copy()
				arguments.Cut(1,2)

				for(var/signal_connection/C in m_map)
					if(C.match(signal))
						if(!C.emit(arguments))
							m_map -= C
							if(!m_map.len) m_map = null